Bug 1927172 - pythran fails to build with Python 3.10: Tests failing with DistutilsExecError/CompileError + distutils DeprecationWarning
Summary: pythran fails to build with Python 3.10: Tests failing with DistutilsExecErro...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: pythran
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1969180 (view as bug list)
Depends On: 1968909 1968986 1981981
Blocks: F35FTBFS F35FailsToInstall PYTHON3.10 1969180
TreeView+ depends on / blocked
 
Reported: 2021-02-10 09:36 UTC by Tomáš Hrnčiar
Modified: 2021-07-14 14:40 UTC (History)
3 users (show)

Fixed In Version: pythran-0.9.12-1.fc35
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-07-14 14:40:45 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2021-02-10 09:36:14 UTC
pythran fails to build with Python 3.10.0a5.

Many tests are failing with different errors.

E       distutils.errors.DistutilsExecError: Command "gcc -pthread -Wno-unused-result -Wsign-compare -DDYNAMIC_ANNOTATIONS_ENABLED=1 -DNDEBUG -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -DENABLE_PYTHON_MODULE -D__PYTHRAN__=3 -DPYTHRAN_BLAS_OPENBLAS -I/usr/include/flexiblas -I/builddir/build/BUILD/pythran-0.9.8post3/pythran -I/usr/lib64/python3.10/site-packages/numpy/core/include -I/usr/include/python3.10 -c /tmp/tmp__dhxqkx.cpp -o /tmp/tmp5wdacpc7/tmp/tmp__dhxqkx.o -std=c++11 -fno-math-errno -w -fvisibility=hidden -fno-wrapv -O0 -Wall -Wno-unknown-pragmas -Wno-mismatched-tags -Wno-unused-local-typedefs -Wno-unknown-warning-option -Werror -UNDEBUG" failed with exit status 1

/usr/lib64/python3.10/site-packages/numpy/distutils/ccompiler.py:173: DistutilsExecError

E           distutils.errors.CompileError: Command "gcc -pthread -Wno-unused-result -Wsign-compare -DDYNAMIC_ANNOTATIONS_ENABLED=1 -DNDEBUG -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -D_GNU_SOURCE -fPIC -fwrapv -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -m64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fPIC -DENABLE_PYTHON_MODULE -D__PYTHRAN__=3 -DPYTHRAN_BLAS_OPENBLAS -I/usr/include/flexiblas -I/builddir/build/BUILD/pythran-0.9.8post3/pythran -I/usr/lib64/python3.10/site-packages/numpy/core/include -I/usr/include/python3.10 -c /tmp/tmp__dhxqkx.cpp -o /tmp/tmp5wdacpc7/tmp/tmp__dhxqkx.o -std=c++11 -fno-math-errno -w -fvisibility=hidden -fno-wrapv -O0 -Wall -Wno-unknown-pragmas -Wno-mismatched-tags -Wno-unused-local-typedefs -Wno-unknown-warning-option -Werror -UNDEBUG" failed with exit status 1

/usr/lib64/python3.10/site-packages/numpy/distutils/unixccompiler.py:57: CompileError

There is also DeprecationWarning.
The distutils package is now deprecated and will be removed in Python 3.12

https://docs.python.org/3.10/whatsnew/changelog.html#python-3-10-0-alpha-5
https://bugs.python.org/issue41282

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01955604-pythran/

For all our attempts to build pythran with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/pythran/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2021-02-18 22:52:59 UTC
It should be fine if this gets fixed after we update to Python 3.10 in rawhide.

Comment 2 Miro Hrončok 2021-06-04 20:15:43 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/

Comment 3 Miro Hrončok 2021-06-07 23:00:05 UTC
The f35-python side tag has been merged to Rawhide. From now on, build as you would normally build.

Comment 4 Miro Hrončok 2021-06-08 11:36:22 UTC
*** Bug 1969180 has been marked as a duplicate of this bug. ***

Comment 5 Miro Hrončok 2021-06-15 20:25:36 UTC
Hello,

This is the first reminder (step 3 from https://docs.fedoraproject.org/en-US/fesco/Fails_to_build_from_source_Fails_to_install/#_package_removal_for_long_standing_ftbfs_and_fti_bugs).

If you know about this problem and are planning on fixing it, please acknowledge so by setting the bug status to ASSIGNED. If you don't have time to maintain this package, consider orphaning it, so maintainers of dependent packages realize the problem.

Comment 6 Miro Hrončok 2021-06-15 20:48:11 UTC
Thanks for the reminder Miro :)

I will deal with this later in the release cycle.

Comment 7 Miro Hrončok 2021-06-23 16:00:57 UTC
No longer a low priority, scipy 1.7.0 (build)requires pythran.

Comment 8 Miro Hrončok 2021-06-23 16:31:55 UTC
If I disable the failing test in gast, pythran fails horribly.

Fixes are required in gast (bz1968986) as well as here.

Comment 9 Miro Hrončok 2021-06-28 23:08:32 UTC
The current Pythran failures are now visible at https://koschei.fedoraproject.org/package/pythran?collection=f35

Comment 10 Fedora Update System 2021-07-14 14:39:06 UTC
FEDORA-2021-ad7cd1747c has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-ad7cd1747c

Comment 11 Fedora Update System 2021-07-14 14:40:45 UTC
FEDORA-2021-ad7cd1747c has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.